package com.steerinfo.meterwork.meterworkbelttiminginfo.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkbelttiminginfo.model.MeterWorkBeltTiminginfo;
import com.steerinfo.meterwork.meterworkbelttiminginfo.service.IMeterWorkBeltTiminginfoService;
import com.steerinfo.meterwork.meterworkstorageactual.model.MeterWorkStorageActual;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkBeltTiminginfo RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-18 11:23
 * 类描述
 * 修订历史：
 * 日期：2021-10-18
 * 作者：generator
 * 参考：
 * 描述：MeterWorkBeltTiminginfo RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkbelttiminginfos")
public class MeterWorkBeltTiminginfoController extends BaseRESTfulController {

    @Autowired
    IMeterWorkBeltTiminginfoService meterWorkBeltTiminginfoService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbelttiminginfo:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltTiminginfo> list = meterWorkBeltTiminginfoService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkbelttiminginfo:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkBeltTiminginfo> list = meterWorkBeltTiminginfoService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkBeltTiminginfo对象创建")
    @ApiImplicitParam(name = "meterWorkBeltTiminginfo", value = "详细实体meterWorkBeltTiminginfo", required = true, dataType = "MeterWorkBeltTiminginfo")
    //@RequiresPermissions("meterworkbelttiminginfo:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkBeltTiminginfo model){
        MeterWorkBeltTiminginfo meterWorkBeltTiminginfo = meterWorkBeltTiminginfoService.add(model);
        return success(meterWorkBeltTiminginfo);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbelttiminginfo:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkBeltTiminginfo meterWorkBeltTiminginfo = meterWorkBeltTiminginfoService.getById(id);
        return success(meterWorkBeltTiminginfo);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkBeltTiminginfo信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkBeltTiminginfo", value = "详细实体meterWorkBeltTiminginfo", required = true, dataType = "MeterWorkBeltTiminginfo")
    })
    //@RequiresPermissions("meterworkbelttiminginfo:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkBeltTiminginfo model){
        model.setId(id);
        MeterWorkBeltTiminginfo meterWorkBeltTiminginfo = meterWorkBeltTiminginfoService.modify(model);
        return success(meterWorkBeltTiminginfo);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkbelttiminginfo:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkBeltTiminginfoService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value = "C#端入库秤实绩", notes = "根据meterworkbelttiminginfo对象创建")
    @ApiImplicitParam(name = "meterworkbelttiminginfo", value = "详细实体meterworkbelttiminginfo", required = true, dataType = "meterworkbelttiminginfo")
    @PostMapping(value = "/doQueryWf")
    public RESTfulResult doQueryWf(@RequestBody CommonPage<MeterWorkBeltTiminginfo> model) {
        try {
            List<MeterWorkBeltTiminginfo> no = meterWorkBeltTiminginfoService.doQueryWf(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "C#端入库秤实绩", notes = "根据meterworkbelttiminginfo对象创建")
    @ApiImplicitParam(name = "meterworkbelttiminginfo", value = "详细实体meterworkbelttiminginfo", required = true, dataType = "meterworkbelttiminginfo")
    @PostMapping(value = "/doAddWf")
    public RESTfulResult doAddWf(@RequestBody MeterWorkBeltTiminginfo model) {
        try {
             int str =  meterWorkBeltTiminginfoService.doAddWf(model);
            return success(str);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

}
